/* new-game-screen.c generated by valac 0.46.5, the Vala compiler
 * generated from new-game-screen.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2015-2016 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of a GNOME game.
 *
 * This application is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this application. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_NEW_GAME_SCREEN (new_game_screen_get_type ())
#define NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreen))
#define NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))
#define IS_NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_GAME_SCREEN))
#define IS_NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_GAME_SCREEN))
#define NEW_GAME_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))

typedef struct _NewGameScreen NewGameScreen;
typedef struct _NewGameScreenClass NewGameScreenClass;
typedef struct _NewGameScreenPrivate NewGameScreenPrivate;
enum  {
	NEW_GAME_SCREEN_0_PROPERTY,
	NEW_GAME_SCREEN_NUM_PROPERTIES
};
static GParamSpec* new_game_screen_properties[NEW_GAME_SCREEN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _NewGameScreen {
	GtkBox parent_instance;
	NewGameScreenPrivate * priv;
};

struct _NewGameScreenClass {
	GtkBoxClass parent_class;
};

struct _NewGameScreenPrivate {
	GtkMenuButton* size_button;
	GtkMenuButton* theme_button;
	GtkBox* games_box;
	GtkBox* options_box;
	GtkLabel* games_label;
	GtkLabel* options_label;
	GtkSeparator* options_separator;
	gboolean phone_size;
	gboolean extra_thin;
	gboolean extra_flat;
};

static gint NewGameScreen_private_offset;
static gpointer new_game_screen_parent_class = NULL;
static AdaptativeWidgetIface * new_game_screen_adaptative_widget_parent_iface = NULL;

GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST;
GType adaptative_widget_get_type (void) G_GNUC_CONST;
GType new_game_screen_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewGameScreen, g_object_unref)
void new_game_screen_update_size_button_label (NewGameScreen* self,
                                               gint size);
void new_game_screen_update_theme (NewGameScreen* self,
                                   const gchar* theme);
static void new_game_screen_real_set_window_size (AdaptativeWidget* base,
                                           AdaptativeWidgetWindowSize new_size);
gboolean adaptative_widget_window_size_is_extra_flat (AdaptativeWidgetWindowSize window_size);
NewGameScreen* new_game_screen_new (void);
NewGameScreen* new_game_screen_construct (GType object_type);
static GObject * new_game_screen_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _new_game_screen___lambda14_ (NewGameScreen* self);
static void __new_game_screen___lambda14__gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static void _new_game_screen___lambda15_ (NewGameScreen* self);
static void __new_game_screen___lambda15__gtk_widget_map (GtkWidget* _sender,
                                                   gpointer self);
static void new_game_screen_finalize (GObject * obj);

static inline gpointer
new_game_screen_get_instance_private (NewGameScreen* self)
{
	return G_STRUCT_MEMBER_P (self, NewGameScreen_private_offset);
}

void
new_game_screen_update_size_button_label (NewGameScreen* self,
                                          gint size)
{
	GtkMenuButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->size_button;
	_tmp1_ = g_strdup_printf (_ ("Size: %d × %d ▾"), size, size);
	_tmp2_ = _tmp1_;
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
}

void
new_game_screen_update_theme (NewGameScreen* self,
                              const gchar* theme)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (theme != NULL);
	_tmp0_ = theme;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("cats")))) {
		switch (0) {
			default:
			{
				GtkMenuButton* _tmp3_;
				_tmp3_ = self->priv->theme_button;
				gtk_button_set_label ((GtkButton*) _tmp3_, _ ("Theme: Cats ▾"));
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("numbers")))) {
		switch (0) {
			default:
			{
				GtkMenuButton* _tmp4_;
				_tmp4_ = self->priv->theme_button;
				gtk_button_set_label ((GtkButton*) _tmp4_, _ ("Theme: Numbers ▾"));
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_warn_if_reached ();
				break;
			}
		}
	}
}

static void
new_game_screen_real_set_window_size (AdaptativeWidget* base,
                                      AdaptativeWidgetWindowSize new_size)
{
	NewGameScreen * self;
	gboolean _extra_flat = FALSE;
	gboolean _extra_thin = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _phone_size = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	self = (NewGameScreen*) base;
	_extra_flat = adaptative_widget_window_size_is_extra_flat (new_size);
	_extra_thin = new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN;
	if (new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT;
	}
	_phone_size = _tmp0_;
	if (_extra_thin == self->priv->extra_thin) {
		_tmp2_ = _phone_size == self->priv->phone_size;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = _extra_flat == self->priv->extra_flat;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		return;
	}
	self->priv->extra_thin = _extra_thin;
	self->priv->phone_size = _phone_size;
	self->priv->extra_flat = _extra_flat;
	if (!_extra_thin) {
		_tmp3_ = !_phone_size;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		if (self->priv->extra_flat) {
			GtkLabel* _tmp4_;
			GtkLabel* _tmp5_;
			GtkBox* _tmp6_;
			GtkBox* _tmp7_;
			GtkSeparator* _tmp8_;
			GtkSeparator* _tmp9_;
			_tmp4_ = self->priv->games_label;
			gtk_widget_hide ((GtkWidget*) _tmp4_);
			_tmp5_ = self->priv->options_label;
			gtk_widget_hide ((GtkWidget*) _tmp5_);
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
			_tmp6_ = self->priv->games_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp6_, GTK_ORIENTATION_VERTICAL);
			_tmp7_ = self->priv->options_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp7_, GTK_ORIENTATION_VERTICAL);
			_tmp8_ = self->priv->options_separator;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp8_, GTK_ORIENTATION_VERTICAL);
			_tmp9_ = self->priv->options_separator;
			gtk_widget_show ((GtkWidget*) _tmp9_);
		} else {
			GtkLabel* _tmp10_;
			GtkLabel* _tmp11_;
			GtkSeparator* _tmp12_;
			GtkBox* _tmp13_;
			GtkBox* _tmp14_;
			GtkBox* _tmp15_;
			_tmp10_ = self->priv->games_label;
			gtk_widget_hide ((GtkWidget*) _tmp10_);
			_tmp11_ = self->priv->options_label;
			gtk_widget_hide ((GtkWidget*) _tmp11_);
			_tmp12_ = self->priv->options_separator;
			gtk_widget_hide ((GtkWidget*) _tmp12_);
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
			_tmp13_ = self->priv->games_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp13_, GTK_ORIENTATION_HORIZONTAL);
			_tmp14_ = self->priv->options_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_HORIZONTAL);
			_tmp15_ = self->priv->games_box;
			gtk_widget_hide ((GtkWidget*) _tmp15_);
		}
	} else {
		if (_phone_size) {
			GtkLabel* _tmp16_;
			GtkLabel* _tmp17_;
			GtkBox* _tmp18_;
			GtkBox* _tmp19_;
			GtkSeparator* _tmp20_;
			GtkSeparator* _tmp21_;
			_tmp16_ = self->priv->games_label;
			gtk_widget_hide ((GtkWidget*) _tmp16_);
			_tmp17_ = self->priv->options_label;
			gtk_widget_hide ((GtkWidget*) _tmp17_);
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
			_tmp18_ = self->priv->games_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
			_tmp19_ = self->priv->options_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp19_, GTK_ORIENTATION_VERTICAL);
			_tmp20_ = self->priv->options_separator;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp20_, GTK_ORIENTATION_HORIZONTAL);
			_tmp21_ = self->priv->options_separator;
			gtk_widget_show ((GtkWidget*) _tmp21_);
		} else {
			GtkSeparator* _tmp22_;
			GtkBox* _tmp23_;
			GtkBox* _tmp24_;
			GtkLabel* _tmp25_;
			GtkLabel* _tmp26_;
			_tmp22_ = self->priv->options_separator;
			gtk_widget_hide ((GtkWidget*) _tmp22_);
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
			_tmp23_ = self->priv->games_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_VERTICAL);
			_tmp24_ = self->priv->options_box;
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp24_, GTK_ORIENTATION_VERTICAL);
			_tmp25_ = self->priv->games_label;
			gtk_widget_show ((GtkWidget*) _tmp25_);
			_tmp26_ = self->priv->options_label;
			gtk_widget_show ((GtkWidget*) _tmp26_);
		}
	}
	gtk_widget_queue_allocate ((GtkWidget*) self);
}

NewGameScreen*
new_game_screen_construct (GType object_type)
{
	NewGameScreen * self = NULL;
	self = (NewGameScreen*) g_object_new (object_type, NULL);
	return self;
}

NewGameScreen*
new_game_screen_new (void)
{
	return new_game_screen_construct (TYPE_NEW_GAME_SCREEN);
}

static void
_new_game_screen___lambda14_ (NewGameScreen* self)
{
	GtkBox* _tmp0_;
	_tmp0_ = self->priv->games_box;
	gtk_widget_show ((GtkWidget*) _tmp0_);
}

static void
__new_game_screen___lambda14__gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
	_new_game_screen___lambda14_ ((NewGameScreen*) self);
}

static void
_new_game_screen___lambda15_ (NewGameScreen* self)
{
	GtkBox* _tmp0_;
	_tmp0_ = self->priv->games_box;
	gtk_widget_show ((GtkWidget*) _tmp0_);
}

static void
__new_game_screen___lambda15__gtk_widget_map (GtkWidget* _sender,
                                              gpointer self)
{
	_new_game_screen___lambda15_ ((NewGameScreen*) self);
}

static GObject *
new_game_screen_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NewGameScreen * self;
	parent_class = G_OBJECT_CLASS (new_game_screen_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_GAME_SCREEN, NewGameScreen);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __new_game_screen___lambda14__gtk_widget_size_allocate, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __new_game_screen___lambda15__gtk_widget_map, self, 0);
	return obj;
}

static void
new_game_screen_class_init (NewGameScreenClass * klass,
                            gpointer klass_data)
{
	new_game_screen_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NewGameScreen_private_offset);
	G_OBJECT_CLASS (klass)->constructor = new_game_screen_constructor;
	G_OBJECT_CLASS (klass)->finalize = new_game_screen_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Taquin/ui/taquin-screens.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_button", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, size_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "theme_button", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, theme_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "games_box", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, games_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_box", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "games_label", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, games_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_label", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_separator", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_separator));
}

static void
new_game_screen_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                                  gpointer iface_data)
{
	new_game_screen_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) new_game_screen_real_set_window_size;
}

static void
new_game_screen_instance_init (NewGameScreen * self,
                               gpointer klass)
{
	self->priv = new_game_screen_get_instance_private (self);
	self->priv->phone_size = FALSE;
	self->priv->extra_thin = FALSE;
	self->priv->extra_flat = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
new_game_screen_finalize (GObject * obj)
{
	NewGameScreen * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_GAME_SCREEN, NewGameScreen);
	_g_object_unref0 (self->priv->size_button);
	_g_object_unref0 (self->priv->theme_button);
	_g_object_unref0 (self->priv->games_box);
	_g_object_unref0 (self->priv->options_box);
	_g_object_unref0 (self->priv->games_label);
	_g_object_unref0 (self->priv->options_label);
	_g_object_unref0 (self->priv->options_separator);
	G_OBJECT_CLASS (new_game_screen_parent_class)->finalize (obj);
}

GType
new_game_screen_get_type (void)
{
	static volatile gsize new_game_screen_type_id__volatile = 0;
	if (g_once_init_enter (&new_game_screen_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewGameScreenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_game_screen_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewGameScreen), 0, (GInstanceInitFunc) new_game_screen_instance_init, NULL };
		static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) new_game_screen_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType new_game_screen_type_id;
		new_game_screen_type_id = g_type_register_static (gtk_box_get_type (), "NewGameScreen", &g_define_type_info, 0);
		g_type_add_interface_static (new_game_screen_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
		NewGameScreen_private_offset = g_type_add_instance_private (new_game_screen_type_id, sizeof (NewGameScreenPrivate));
		g_once_init_leave (&new_game_screen_type_id__volatile, new_game_screen_type_id);
	}
	return new_game_screen_type_id__volatile;
}

